<template>
  <div class="pinPad">
    <div class="pinPad_header"
         :class="error ? 'pinPad_header-error': ''">
      <div
        class="pinPad_header-input"
        v-for="(item, key) in values"
        :key="key">
        {{item}}
      </div>
    </div>
    <div class="pinPad_inner">
      <div class="pinPad_body">
        <button
          class="pinPad_btn"
          v-for="(item, key) in keyboard"
          :key="key"
          @click="press(item)">
          <div class="pinPad_btn-num">{{item.key}}</div>
          <div class="pinPad_btn-char">{{item.label}}</div>
        </button>
      </div>
    </div>
  </div>
</template>

<script>
  export default {
    name: "PinCode",
    props: {
      error: {
        type: Boolean,
        default: false
      }
    },
    data() {
      return {
        values: {
          1: '',
          2: '',
          3: '',
          4: ''
        },
        currentIndex: 0,
        keyboard:
          [{
            key: 1,
            label: ''
          }, {
            key: 2,
            label: 'abc'
          }, {
            key: 3,
            label: 'def'
          }, {
            key: 4,
            label: 'ghi'
          }, {
            key: 5,
            label: 'jkl'
          }, {
            key: 6,
            label: 'mno'
          }, {
            key: 7,
            label: 'pqrs'
          }, {
            key: 8,
            label: 'tuv'
          }, {
            key: 9,
            label: 'wxyz'
          }, {
            key: '<',
            label: ''
          }, {
            key: 0,
            label: ''
          }, {
            key: 'C',
            label: ''
          }]
      }
    },
    computed: {},
    methods: {
      press({key}) {
        if (typeof key === 'number' && this.currentIndex < 4) {
          this.currentIndex += 1;
          this.values[this.currentIndex] = key;
          this.$emit('change', Object.values(this.values).join(''));
          return;
        }
        switch (key) {
          case '<': {
            if (this.currentIndex > 0) {
              this.values[this.currentIndex] = '';
              this.currentIndex -= 1;
            }
            break;
          }
          case 'C': {
            this.clear();
            break;
          }
        }
      },
      clear() {
        this.values = {
          1: '',
          2: '',
          3: '',
          4: ''
        };
        this.currentIndex = 0;
      }
    }
  }
</script>
